UNIT Stdio;

{$I OsWahl.inc}

{$IFDEF WIN_3264}
{ $DEFINE CP_FRAGE} (* nur setzen in Win32/64 ZITATE Batch&Online *)
{$ENDIF}
{ $DEFINE CP_AUS}

{$IFDEF DOS} {$M 65520,0,655360} {$N+}
{$ELSE} {$mode objfpc} {$H+}
        {$IFDEF X86_64} {$MAXSTACKSIZE $7FFFFFF} {$ENDIF}
{$ENDIF}

INTERFACE

CONST VERSION_INFO_Stdio = 'Stdio   V 2.43 '
{$IFDEF LINUX_32} + '(Linux 32)' {$ENDIF} {$IFDEF LINUX_64} + '(Linux 64)' {$ENDIF}
{$IFDEF WIN_32}   + '(32bit)'    {$ENDIF} {$IFDEF WIN_64}   + '(64bit)'    {$ENDIF}
{$IFDEF BIT_16}   + '(16bit)'    {$ENDIF} + ' 02.04.2025   (c) ALFWARE B.Schubert';

SLASH = {$IFDEF LINUX} '/' {$ELSE} '\' {$ENDIF} ;

TYPE
  CARD = {$IFDEF DOS} LONGINT {$ELSE} INT64 {$ENDIF};
  mySTRING = {$IFDEF WIN_3264} TYPE AnsiString(850) {$ELSE} STRING {$ENDIF};
  STRING8 = STRING[8];

CONST
  MAXCARD = {$IFDEF DOS} MAXLONGINT {$ELSE} HIGH(INT64) {$ENDIF};
  MAXHALF = MAXCARD DIV 2;
  KILO=1024; MEGA=1024*1024; GIGA=1024*1024*1024;
  CP_WUNSCH = 1252;

VAR
  _ae, _oe, _ue, _AE2, _OE2, _UE2, _sz, _eu, _eu1, _eu2, _eu3, _gr, _h2, _h3, _pg: STRING8;
  ZEICHENSATZ, ZEICHENSATZ0, UMLAUTE: STRING;
  _codepage, _codepage_alt: INTEGER;

{$IFNDEF DOS}
VAR
  Keyboard_OK: BOOLEAN;
  (* wird True vorbelegt *)
  Keyboard_Auto: BOOLEAN;
  (* wird False vorbelegt *)

PROCEDURE Keyboard_Start;
PROCEDURE Keyboard_Stop;
(* m_oeglichst nur bei NULLDISK aufrufen? *)
{$ENDIF}

PROCEDURE Taste;
(* wartet nur auf Tastendruck *)

FUNCTION TasteZ: CHAR;
(* liest von der Tastatur, mit R_ueckgabe des Zeichens *)

FUNCTION TasteC: INTEGER;
(* liest von der Tastatur, mit R_ueckgabe des Codes *)

FUNCTION TasteS: String;
(* liest von der Tastatur, mit R_ueckgabe (erweitert) *)

FUNCTION Taste0: CHAR;
(* liest von der Tastatur, intern *)

FUNCTION KeyPressed0: BOOLEAN;
(* Taste gedr_ueckt? *)

FUNCTION Taste_Test: BOOLEAN;
(* Taste wurde zuletzt gedr_ueckt *)

PROCEDURE Taste_Reset;
(* R_uecksetzen der (asynchronen) Tastenabfrage *)

{$IFDEF DOS}
(* Nutzen nur Int $16 *)
FUNCTION Taste1:CHAR;
(* liest von der Tastatur *)

FUNCTION KeyPressed1: BOOLEAN;
(* Taste gedr_ueckt? *)

(* Nutzen Unit KB *)
FUNCTION Taste2:CHAR;
(* liest von der Tastatur *)

FUNCTION KeyPressed2: BOOLEAN;
(* Taste gedr_ueckt? *)
{$ENDIF}

FUNCTION uml(nr: BYTE):STRING8;
(* Umlaute _ueber chr *)

FUNCTION UpString(s:STRING):STRING;
(* wandelt den gesamten String im Gro_szbuchstaben *)

FUNCTION ReplaceInString(s:STRING; cvon,cnach:CHAR):STRING;
(*  ersetzt in s alle cvon durch cnach *)

FUNCTION DeleteInString(s:STRING; c:CHAR):STRING;
(*  l_oescht in s alle c *)

FUNCTION Double2String(n:DOUBLE; de:INTEGER):STRING;
(* wandelt ein Double in einen String.
   Achtung, das Zwischenergebnis darf MaxLongint bzw. MaxInt64 nicht _ueberschreiten *)

FUNCTION Str0(n,anz:INTEGER):STRING;
(* Integer fester L_aenge (mit Vornullen) *)

FUNCTION StrLong(n:LONGINT):STRING;
(* LongInt wird lesbarer mit . *)

FUNCTION Str0Long(n:LONGINT; anz:INTEGER):STRING;
(* LongInt fester L_aenge (mit Vornullen) *)

FUNCTION StrLiLong(n:LONGINT; anz:INTEGER):STRING;
(* LongInt fester L_aenge (linksb_uendig mit Nach-blanks) *)

FUNCTION StrReLong(n:LONGINT; anz:INTEGER):STRING;
(* LongInt fester L_aenge (rechtsb_uendig mit Vor-blanks) *)

{$IFNDEF DOS}
FUNCTION StrInt64(n:INT64):STRING;
(* Int64 wird lesbarer mit . *)

FUNCTION Str0Int64(n:INT64; anz:INTEGER):STRING;
(* Int64 fester L_aenge (mit Vornullen) *)
{$ENDIF}

FUNCTION StrCard(n: CARD):STRING;
(* Card: Long (DOS) bzw INT64 *)

FUNCTION Str0Card(n: CARD; anz:INTEGER):STRING;
(* Card: Long (DOS) bzw INT64 *)

FUNCTION StrDouble(n:DOUBLE):STRING;
(* Double wird lesbarer mit . *)

FUNCTION Str0Double(n:DOUBLE; anz:INTEGER):STRING;
(* Double fester L_aenge (mit Vornullen) *)

FUNCTION StrkDouble(n:DOUBLE; de:INTEGER):STRING;
(* Double wird lesbarer mit . MIT Komma *)

FUNCTION Str0kDouble(n:DOUBLE; anz,de:INTEGER):STRING;
(* Double fester L_aenge (mit Vornullen) MIT Komma *)

FUNCTION StrExtended(n:EXTENDED):STRING;
(* Extended wird lesbarer mit . *)

FUNCTION Str0Extended(n:EXTENDED; anz:INTEGER):STRING;
(* Extended fester L_aenge (mit Vornullen) *)

FUNCTION StrkExtended(n:EXTENDED; de:INTEGER):STRING;
(* Extended wird lesbarer mit . MIT Komma *)

FUNCTION Str0kExtended(n:EXTENDED; anz,de:INTEGER):STRING;
(* Extended fester L_aenge (mit Vornullen) MIT Komma *)

FUNCTION StrCompN(n:COMP):STRING;
(* COMP wird lesbarer mit . *)

FUNCTION Str0CompN(n:COMP; anz:INTEGER):STRING;
(* COMP fester L_aenge (mit Vornullen) *)

FUNCTION StrkCompN(n:COMP; de:INTEGER):STRING;
(* COMP wird lesbarer mit . MIT Komma *)

FUNCTION Str0kCompN(n:COMP; anz,de:INTEGER):STRING;
(* COMP fester L_aenge (mit Vornullen) MIT Komma *)

(* rufe diese Funktionen f_uer kleinere Double-Zahlen
   und spare den Numeric-Processor f_uer STR(n:anz:dec) *)
FUNCTION StrSoftReal(n:DOUBLE):STRING;
(* Double wird lesbarer mit . *)

FUNCTION Str0SoftReal(n:DOUBLE; anz:INTEGER):STRING;
(* Double fester L_aenge (mit Vornullen) *)

FUNCTION StrkSoftReal(n:DOUBLE; de:INTEGER):STRING;
(* Double wird lesbarer mit . MIT Komma *)

FUNCTION Str0kSoftReal(n:DOUBLE; anz,de:INTEGER):STRING;
(* Double fester L_aenge (mit Vornullen) MIT Komma *)

FUNCTION Str0Giga(wert: CARD):STRING;
(* CardInt mit ggf. K/M/G *)

FUNCTION Str2Int(S: STRING): INTEGER;
(* wandelt String in Integer *)

FUNCTION Str2Card(S: STRING): CARD;
(* wandelt String in CARD *)

PROCEDURE stdHilfe(hinweis: STRING);
PROCEDURE Fehler_stdio(ursache:BYTE; name:STRING);
PROCEDURE Open_stdEingabe;
PROCEDURE Close_stdEingabe;
PROCEDURE Open_stdAusgabe;
PROCEDURE Close_stdAusgabe;
FUNCTION stdEOF: boolean;
FUNCTION stdReadln: string;
PROCEDURE stdWriteln(writezeile: STRING);
PROCEDURE Open_stdProtokoll(name: STRING);
PROCEDURE Close_stdProtokoll;
FUNCTION Bytes_stdFile(einname: STRING):CARD;
FUNCTION Zeilen_stdEingabe(einname: STRING):CARD;
FUNCTION Mittel_stdEingabe(einname: STRING):CARD;
PROCEDURE Kopieren_Zeilen(einname,ausname: STRING);

{$IFDEF CP_FRAGE}
PROCEDURE WriteUTF8(s: STRING);
PROCEDURE WritelnUTF8(s: STRING);
{$ENDIF}

VAR
  stdEingabe, stdAusgabe, stdProtokoll: TEXT;
  stdFile: FILE;
  stdZeile, stdEinName, stdAusName: STRING;
  stdEinZahl, stdAusZahl: LONGINT;
  okstdProt, stdEinPipe, stdAusPipe: BOOLEAN;

IMPLEMENTATION

{$IFDEF DOS}

USES DOS, NewCrt, KB;

CONST
  maxSoftReal: DOUBLE = 2.1e9;
  tempDOS: String = '';

(* Nutzen der Unit NewCrt *)
FUNCTION Taste0:CHAR;
BEGIN
  Taste0:=ReadKey;
END (* Taste0 *);

FUNCTION KeyPressed0: BOOLEAN;
BEGIN
  KeyPressed0:=KeyPressed;
END (* KeyPressed0 *);

(* Nutzen nur INT $16 *)
FUNCTION Taste1:CHAR;
VAR
  cc:WORD;
  regs:REGISTERS;
BEGIN
  regs.AH:=$00; INTR($16,regs);
  cc:=regs.AL; Taste1:=CHR(cc);
END (* Taste1 *);

FUNCTION KeyPressed1: BOOLEAN;
VAR
  regs:REGISTERS;
  ZF:BOOLEAN;
BEGIN
  regs.AH:=$01; INTR($16,regs); 
  ZF:=(regs.FLAGS AND $0040 = $0040); (* ZF Bit 6 *)
  KeyPressed1:=NOT ZF;
END (* KeyPressed1HEX *);

(* Nutzen der Unit KB (ASM) *)
FUNCTION Taste2:CHAR;
VAR
  cc:WORD;
BEGIN
  KB_read(cc); Taste2:=CHR(cc);
END (* Taste2 *);

FUNCTION KeyPressed2: BOOLEAN;
BEGIN
  KeyPressed2:=KB_pressed;
END (* KeyPressed2 *);

(* DOS *)
FUNCTION TasteC:INTEGER;
VAR c:INTEGER;
BEGIN
  c:=Ord(Taste0);
  IF c=0 THEN c:=255+Ord(Taste0);
  TasteC:=c;
END (* TasteC *);

{$ELSE}

USES KeyBoard {$IFDEF CP_FRAGE} , Windows {$ENDIF};

CONST
  maxSoftReal: DOUBLE = 9.2e18;
  Keyboard_Kombi: BOOLEAN = False;
  Keyboard_Aktiv: BOOLEAN = False;

VAR
  K:TKeyEvent;
  ch:CHAR;

FUNCTION Taste0:CHAR;
BEGIN
  IF NOT Keyboard_OK THEN EXIT;
  IF ch<>CHR(0) THEN BEGIN
     Taste0:=ch; ch:=CHR(0); EXIT;
  END;
  IF NOT Keyboard_Aktiv THEN BEGIN
    InitKeyboard; Keyboard_Aktiv:=True;
  END;
  K:=GetKeyEvent;
  K:=TranslateKeyEvent(K);
  CASE GetKeyEventFlags(K) OF
    (* ESC, ENTER, BACKSPACE kommen als ASCII an *)
    kbASCII : ch:=GetKeyEventChar(K);
    kbFnKey :
      CASE GetKeyEventCode(K) OF
        65313 : ch:=CHR(200); (* up     *)
        65319 : ch:=CHR(208); (* down   *)
        65315 : ch:=CHR(203); (* left   *)
        65317 : ch:=CHR(205); (* right  *)
        65312 : ch:=CHR(199); (* pos1   *)
        65318 : ch:=CHR(207); (* end    *)
        65321 : ch:=CHR(210); (* insert *)
        65322 : ch:=CHR(211); (* delete *)
        65281..65292: ch:=CHR(GetKeyEventCode(K)-65094); (* Funktionstasten *)
        ELSE
      END;
    ELSE
  END;
  Taste0:=ch;
  IF Keyboard_Auto THEN
    IF Keyboard_Aktiv THEN BEGIN
      DoneKeyboard; Keyboard_Aktiv:=False;
      Keyboard_Kombi:=False;
  END;
END (* Taste0 *);

FUNCTION KeyPressed0:BOOLEAN;
BEGIN
  IF NOT Keyboard_OK THEN EXIT;
  IF Keyboard_Auto THEN
    IF NOT Keyboard_Aktiv THEN BEGIN
      InitKeyboard; Keyboard_Aktiv:=True;
      Keyboard_Kombi:=True;
  END;
  K:=PollKeyEvent;
  IF K<>0
     THEN BEGIN ch:=Taste0; KeyPressed0:=True; END
     ELSE KeyPressed0:=False;
  IF NOT Keyboard_Auto AND NOT Keyboard_Kombi THEN
     IF Keyboard_Aktiv THEN BEGIN
     DoneKeyboard; Keyboard_Aktiv:=False;
  END;
END (* KeyPressed0 *);

PROCEDURE Keyboard_Start;
BEGIN
  IF NOT Keyboard_OK THEN EXIT;
  InitKeyBoard; Keyboard_Aktiv:=True;
  Keyboard_Auto:=True;
  Keyboard_Kombi:=False;
END (* KeyBoard_Start *);

PROCEDURE Keyboard_Stop;
BEGIN
  IF NOT Keyboard_OK THEN EXIT;
  DoneKeyBoard; Keyboard_Aktiv:=False;
  Keyboard_Auto:=False;
END (* KeyBoard_Stop *);

FUNCTION TasteC:INTEGER;
VAR c:INTEGER;
BEGIN
  REPEAT UNTIL Keypressed0;
  c:=Ord(Taste0);
  IF c=0 THEN c:=255+Ord(Taste0);
  TasteC:=c;
END (* TasteC *);

{$ENDIF}

CONST Taste_Gedrueckt: BOOLEAN = False;

FUNCTION TasteS:String;
VAR c:INTEGER;
BEGIN
  c:=TasteC;
  IF c>255
    THEN TasteS:='#'+Chr(c-255)
    ELSE TasteS:=Chr(c);
END (* TasteS *);

FUNCTION TasteZ:CHAR;
BEGIN
  TasteZ:=Chr(TasteC);
END (* TasteZ *);

PROCEDURE Taste;
BEGIN
  TasteC;
END (* Taste *);

FUNCTION Taste_Test:BOOLEAN;
BEGIN
  IF NOT Taste_Gedrueckt AND Keypressed0 THEN BEGIN
    Taste0; Taste_Gedrueckt:=True;
  END;
  Taste_Test:=Taste_Gedrueckt;
END (* Taste_Test *);

PROCEDURE Taste_Reset;
BEGIN
   Taste_Gedrueckt:=False;
END (* Taste_Reset *);

FUNCTION uml(nr: BYTE):STRING8;
   FUNCTION setze(chr_UTF8, chr_CP437, chr_CP850, chr_CP1252: STRING8):STRING8;
   (* 437, 850, 1252, UTF8 beachten *)
   BEGIN
      CASE _codepage OF
        0    :  setze:=chr_UTF8;
        850  :  setze:=chr_CP850;
        437  :  setze:=chr_CP437;
        1252 :  setze:=chr_CP1252;
        ELSE    setze:='';
      END;
   END;
BEGIN
   (**********
        CP437    CP850    CP1252   UTF8
   AE   8E/142   8E/142   C4/196   C3+84/195+132
   OE   99/153   99/153   D6/214   C3+96/195+150
   UE   9A/154   9A/154   DC/220   C3+9C/195+156
   ae   84/132   84/132   E4/228   C3+A4/195+164
   oe   94/148   94/148   F6/246   C3+B6/195+182
   ue   81/129   81/129   FC/252   C3+BC/195+188
   sz   E1/225   E1/225   DF/223   C3+9F/195+159
   gr   F8/248   F8/248   B0/176   C2+B0/194+176
   h2   FD/253   FD/253   B2/178   C2+B2/194+178
   h3   20/32    FC/252   B3/179   C2+B3/194+179
   pg   15/21    F5/245   A7/167   C2+A7/194+167
   eu   80/128   80/128   C7/199   E2+82+AC/226+130+172   *EE/238 **A2/162
   **********)
   CASE nr OF
     (* SZ UTF8: C3+9F/195+159 CP437: E1/225 CP850: E1/225 CP1252: DF/223 *)
     0 : uml:= setze(chr(195) + chr(159), chr(225), chr(225), chr(223) );

     (* AE UTF8: C3+84/195+132 CP437: 8E/142 CP850: 8E/142 CP1252: C4/196  *)
     1 : uml:= setze(chr(195) + chr(132), chr(142), chr(142), chr(196) );

     (* OE UTF8: C3+96/195+150 CP437: 99/153 CP850: 99/153 CP1252: D6/214 *)
     2 : uml:= setze(chr(195) + chr(150), chr(153), chr(153), chr(214) );

     (* UE UTF8: C3+9C/195+156 CP437: 9A/154 CP850: 9A/154 CP1252: DC/220 *)
     3 : uml:= setze(chr(195) + chr(156), chr(154), chr(154), chr(220) );

     (* ae UTF8: C3+A4/195+164 CP437: 84/132 CP850: 84/132 CP1252: E4/228 *)
     11 : uml:= setze(chr(195) + chr(164), chr(132), chr(132), chr(228) );

     (* oe UTF8: C3+B6/195+182 CP437: 94/148 CP850: 94/148 CP1252: F6/246 *)
     12 : uml:= setze(chr(195) + chr(182), chr(148), chr(148), chr(246) );

     (* ue UTF8: C3+BC/195+188 CP437: 81/129 CP850: 81/129 CP1252: FC/252 *)
     13 : uml:= setze(chr(195) + chr(188), chr(129), chr(129), chr(252) );

     (* gr UTF8: C2+B0/194+176 CP437: F8/248 CP850: F8/248 CP1252: B0/176 *)
     21 : uml:=setze(chr(194) + chr(176), chr(248), chr(248), chr(176) );

     (* h2 UTF8: C2+B2/194+178 CP437: FD/253 CP850: FD/253 CP1252: B2/178 *)
     22 : uml:=setze(chr(194) + chr(178), chr(253), chr(253), chr(178) );

     (* h3 UTF8: C2+B3/194+179 CP437: FC/252 CP850: FC/252 CP1252: B3/179 *)
     23 : uml:=setze(chr(194) + chr(179), chr(252), chr(252), chr(179) );

     (* pg UTF8: C2+A7/194+167 CP437: 15/21 CP850: F5/245 CP1252: A7/167 *)
     24 : uml:=setze(chr(194) + chr(167), chr(21), chr(245), chr(167) );

     (* eu UTF8: E2+82+AC/226+130+172 CP437: 80/128 CP850: 80/128 CP1252: C7/199 *)
     30 : uml:=setze(chr(226) + chr(130) + chr(172), chr(128), chr(128), chr(199));
     31 : uml:=setze('E',   'E',   'E',   'E' );
     32 : uml:=setze('EU',  'EU',  'EU',  'EU' );
     33 : uml:=setze('EUR', 'EUR', 'EUR', 'EUR' );
     ELSE uml:='';
   END
END;

{$IFDEF CP_FRAGE}
PROCEDURE WriteUTF8(s: STRING);
BEGIN
   _codepage_alt:=GetConsoleCP;
   {$IFDEF CP_AUS} Writeln('akt CP: ', GetConsoleCP); {$ENDIF}
   SetConsoleCP(CP_UTF8);
   {$IFDEF CP_AUS} Writeln('temp CP: ', GetConsoleCP); {$ENDIF}
   Write(s);
   SetConsoleCP(_codepage_alt);
   {$IFDEF CP_AUS} Writeln('akt CP: ', GetConsoleCP); {$ENDIF}
END;

PROCEDURE WritelnUTF8(s: STRING);
BEGIN
   WriteUTF8(s); Writeln;
END;
{$ENDIF}

FUNCTION UpString(s:STRING):STRING;
VAR
  t:STRING;
BEGIN
  t:='';
  WHILE s<>'' DO BEGIN t:=t+UPCASE(s[1]); s:=COPY(s,2,LENGTH(s)-1); END;
  UpString:=t;
END; (* Upstring *)

FUNCTION ReplaceInString(s:STRING; cvon,cnach:CHAR):STRING;
VAR
  s0:STRING; i:INTEGER;
BEGIN
  s0:=s; i:=POS(cvon,s0);
  WHILE i>0 DO BEGIN
    s0:=COPY(s0,1,i-1)+cnach+COPY(s0,i+1,255);
    i:=POS(cvon,s0);
  END;
  ReplaceInString:=s0;
END;

FUNCTION DeleteInString(s:STRING; c:CHAR):STRING;
VAR
  s0:STRING; i:INTEGER;
BEGIN
  s0:=s; i:=POS(c,s0);
  WHILE i>0 DO BEGIN
    s0:=COPY(s0,1,i-1)+COPY(s0,i+1,255);
    i:=POS(c,s0);
  END;
  DeleteInString:=s0;
END;

FUNCTION Double2String(n:DOUBLE; de:INTEGER):STRING;
VAR
  s0,s1:STRING; i:INTEGER;
  vz:BOOLEAN;
  nk:DOUBLE;
  g:CARD;
BEGIN
  IF abs(n) > maxSoftReal THEN BEGIN Double2String:='SoftReal OFL'; EXIT; END;
  vz:=(n < 0.0); n:=ABS(n);
  g:=TRUNC(n); STR(g,s0);
  IF vz THEN s0:='-' + s0;
  IF de > 0 THEN BEGIN
    nk:=n-g;
    FOR i:=1 TO de DO nk:=nk*10;
    g:=TRUNC(nk); s1:=Str0(g,de);
  END;
  IF de = 0
    THEN Double2String:=s0
    ELSE Double2String:=s0+','+s1;
END;

FUNCTION Str0(n,anz:INTEGER):STRING;
VAR
  s0,s1:STRING; i:INTEGER;
BEGIN
  STR(n,s0); s1:='';
  FOR i:=anz-LENGTH(s0) DOWNTO 1 DO s1:=s1+'0';
  Str0:=s1+s0;
END (* Str0 *);

FUNCTION StrLong(n:LONGINT):STRING;
VAR
  s0,s1:STRING; i,j:INTEGER;
  vzab:INTEGER;
BEGIN
  STR(n,s0); s1:=''; j:=0;
  vzab:=POS('-',s0);
  FOR i:=LENGTH(s0) DOWNTO 1 DO BEGIN
    IF i<>vzab THEN BEGIN
      IF (j MOD 3 = 0) AND (j>0) THEN s1:='.'+s1;
      INC(j);
    END;
    s1:=s0[i]+s1;
  END;
  StrLong:=s1;
END (* StrLong *);

FUNCTION Str0Long(n:LONGINT; anz:INTEGER):STRING;
VAR
  s0,s1:STRING; i:INTEGER;
BEGIN
  STR(n,s0); s1:='';
  FOR i:=anz-LENGTH(s0) DOWNTO 1 DO s1:=s1+'0';
  Str0Long:=s1+s0;
END (* Str0Long *);

FUNCTION StrLiLong(n:LONGINT; anz:INTEGER):STRING;
VAR
  s0,s1:STRING; i:INTEGER;
BEGIN
  STR(n,s0); s1:='';
  FOR i:=anz-LENGTH(s0) DOWNTO 1 DO s1:=s1+' ';
  StrLiLong:=s0+s1;
END (* StrLiLong *);

FUNCTION StrReLong(n:LONGINT; anz:INTEGER):STRING;
VAR
  s0,s1:STRING; i:INTEGER;
BEGIN
  STR(n,s0); s1:='';
  FOR i:=anz-LENGTH(s0) DOWNTO 1 DO s1:=s1+' ';
  StrReLong:=s1+s0;
END (* StrReLong *);

{$IFNDEF DOS}
FUNCTION StrInt64(n:INT64):STRING;
VAR
  s0,s1:STRING; i,j:INTEGER;
  vzab:INTEGER;
BEGIN
  STR(n,s0); s1:=''; j:=0;
  vzab:=POS('-',s0);
  FOR i:=LENGTH(s0) DOWNTO 1 DO BEGIN
    IF i<>vzab THEN BEGIN
      IF (j MOD 3 = 0) AND (j>0) THEN s1:='.'+s1;
      INC(j);
    END;
    s1:=s0[i]+s1;
  END;
  StrInt64:=s1;
END (* StrInt64 *);

FUNCTION Str0Int64(n:INT64; anz:INTEGER):STRING;
VAR
  s0,s1:STRING; i:INTEGER;
BEGIN
  STR(n,s0); s1:='';
  FOR i:=anz-LENGTH(s0) DOWNTO 1 DO s1:=s1+'0';
  Str0Int64:=s1+s0;
END (* Str0Int64 *);
{$ENDIF}

FUNCTION StrCard(n: CARD):STRING;
BEGIN
  StrCard:= {$IFDEF DOS} StrLong {$ELSE} StrInt64 {$ENDIF} (n);
END;

FUNCTION Str0Card(n: CARD; anz:INTEGER):STRING;
BEGIN
  Str0Card:= {$IFDEF DOS} Str0Long {$ELSE} Str0Int64 {$ENDIF} (n,anz);
END;

FUNCTION StrDouble(n:DOUBLE):STRING;
VAR
  s0,s1:STRING; i,j:INTEGER;
  vzab:INTEGER;
BEGIN
  STR(n:1:0,s0); s1:=''; j:=0;
  vzab:=POS('-',s0);
  FOR i:=LENGTH(s0) DOWNTO 1 DO BEGIN
    IF i<>vzab THEN BEGIN
      IF (j MOD 3 = 0) AND (j>0) THEN s1:='.'+s1;
      INC(j);
    END;
    s1:=s0[i]+s1;
  END;
  StrDouble:=s1;
END (* StrDouble *);

FUNCTION Str0Double(n:DOUBLE; anz:INTEGER):STRING;
VAR
  s0,s1:STRING; i:INTEGER;
BEGIN
  STR(n:1:0,s0); s1:='';
  FOR i:=anz-LENGTH(s0) DOWNTO 1 DO s1:=s1+'0';
  Str0Double:=s1+s0;
END (* Str0Double *);

FUNCTION StrkDouble(n:DOUBLE; de:INTEGER):STRING;
VAR
  s0,s1:STRING; i,j:INTEGER;
  dzp,vzab:INTEGER;
BEGIN
  STR(n:1:de,s0); s1:=''; j:=0;
  s0:=ReplaceInString(s0,'.',',');
  vzab:=POS('-',s0); dzp:=POS(',',s0);
  FOR i:=LENGTH(s0) DOWNTO 1 DO BEGIN
    IF ((i<dzp) or (dzp=0)) AND (i<>vzab) THEN BEGIN
      IF (j MOD 3 = 0) AND (j>0) THEN s1:='.'+s1;
      INC(j);
    END;
    s1:=s0[i]+s1;
  END;
  StrkDouble:=s1;
END (* StrkDouble *);

FUNCTION Str0kDouble(n:DOUBLE; anz,de:INTEGER):STRING;
VAR
  s0,s1:STRING; i:INTEGER;
BEGIN
  STR(n:1:de,s0); s1:='';
  s0:=ReplaceInString(s0,'.',',');
  FOR i:=anz-LENGTH(s0) DOWNTO 1 DO s1:=s1+'0';
  Str0kDouble:=s1+s0;
END (* Str0kDouble *);

FUNCTION StrExtended(n:EXTENDED):STRING;
VAR
  s0,s1:STRING; i,j:INTEGER;
  vzab:INTEGER;
BEGIN
  STR(n:1:0,s0); s1:=''; j:=0;
  vzab:=POS('-',s0);
  FOR i:=LENGTH(s0) DOWNTO 1 DO BEGIN
    IF i<>vzab THEN BEGIN
      IF (j MOD 3 = 0) AND (j>0) THEN s1:='.'+s1;
      INC(j);
    END;
    s1:=s0[i]+s1;
  END;
  StrExtended:=s1;
END (* StrExtended *);

FUNCTION Str0Extended(n:EXTENDED; anz:INTEGER):STRING;
VAR
  s0,s1:STRING; i:INTEGER;
BEGIN
  STR(n:1:0,s0); s1:='';
  FOR i:=anz-LENGTH(s0) DOWNTO 1 DO s1:=s1+'0';
  Str0Extended:=s1+s0;
END (* Str0Extended *);

FUNCTION StrkExtended(n:EXTENDED; de:INTEGER):STRING;
VAR
  s0,s1:STRING; i,j:INTEGER;
  dzp,vzab:INTEGER;
BEGIN
  STR(n:1:de,s0); s1:=''; j:=0;
  s0:=ReplaceInString(s0,'.',',');
  vzab:=POS('-',s0); dzp:=POS(',',s0);
  FOR i:=LENGTH(s0) DOWNTO 1 DO BEGIN
    IF ((i<dzp) or (dzp=0)) AND (i<>vzab) THEN BEGIN
      IF (j MOD 3 = 0) AND (j>0) THEN s1:='.'+s1;
      INC(j);
    END;
    s1:=s0[i]+s1;
  END;
  StrkExtended:=s1;
END (* StrkExtended *);

FUNCTION Str0kExtended(n:EXTENDED; anz,de:INTEGER):STRING;
VAR
  s0,s1:STRING; i:INTEGER;
BEGIN
  STR(n:1:de,s0); s1:='';
  s0:=ReplaceInString(s0,'.',',');
  FOR i:=anz-LENGTH(s0) DOWNTO 1 DO s1:=s1+'0';
  Str0kExtended:=s1+s0;
END (* Str0kExtended *);

FUNCTION StrCompN(n:COMP):STRING;
VAR
  s0,s1:STRING; i,j:INTEGER;
  vzab:INTEGER;
BEGIN
  STR(n:1{$IFNDEF WIN_64}:0{$ENDIF},s0); s1:=''; j:=0;
  vzab:=POS('-',s0);
  FOR i:=LENGTH(s0) DOWNTO 1 DO BEGIN
    IF i<>vzab THEN BEGIN
      IF (j MOD 3 = 0) AND (j>0) THEN s1:='.'+s1;
      INC(j);
    END;
    s1:=s0[i]+s1;
  END;
  StrCompN:=s1;
END (* StrCompN *);

FUNCTION Str0CompN(n:COMP; anz:INTEGER):STRING;
VAR
  s0,s1:STRING; i:INTEGER;
BEGIN
  STR(n:1{$IFNDEF WIN_64}:0{$ENDIF},s0); s1:='';
  FOR i:=anz-LENGTH(s0) DOWNTO 1 DO s1:=s1+'0';
  Str0CompN:=s1+s0;
END (* Str0CompN *);

FUNCTION StrkCompN(n:COMP; de:INTEGER):STRING;
VAR
  s0,s1:STRING; i,j:INTEGER;
  dzp,vzab:INTEGER;
BEGIN
  STR(n:1{$IFNDEF WIN_64}:de{$ENDIF},s0); s1:=''; j:=0;
  s0:=ReplaceInString(s0,'.',',');
  vzab:=POS('-',s0); dzp:=POS(',',s0);
  FOR i:=LENGTH(s0) DOWNTO 1 DO BEGIN
    IF ((i<dzp) or (dzp=0)) AND (i<>vzab) THEN BEGIN
      IF (j MOD 3 = 0) AND (j>0) THEN s1:='.'+s1;
      INC(j);
    END;
    s1:=s0[i]+s1;
  END;
  StrkCompN:=s1;
END (* StrkCompN *);

FUNCTION Str0kCompN(n:COMP; anz,de:INTEGER):STRING;
VAR
  s0,s1:STRING; i:INTEGER;
BEGIN
  STR(n:1{$IFNDEF WIN_64}:de{$ENDIF},s0); s1:='';
  s0:=ReplaceInString(s0,'.',',');
  FOR i:=anz-LENGTH(s0) DOWNTO 1 DO s1:=s1+'0';
  Str0kCompN:=s1+s0;
END (* Str0kCompN *);

FUNCTION StrSoftReal(n:DOUBLE):STRING;
VAR
  s0,s1:STRING; i,j:INTEGER;
  vzab:INTEGER;
BEGIN
  IF abs(n) > maxSoftReal THEN BEGIN StrSoftReal:='SoftReal OFL'; EXIT; END;
  s0:=Double2String(n,0); s1:=''; j:=0;
  vzab:=POS('-',s0);
  FOR i:=LENGTH(s0) DOWNTO 1 DO BEGIN
    IF i<>vzab THEN BEGIN
      IF (j MOD 3 = 0) AND (j>0) THEN s1:='.'+s1;
      INC(j);
    END;
    s1:=s0[i]+s1;
  END;
  StrSoftReal:=s1;
END (* StrSoftReal *);

FUNCTION Str0SoftReal(n:DOUBLE; anz:INTEGER):STRING;
VAR
  s0,s1:STRING; i:INTEGER;
BEGIN
  IF abs(n) > maxSoftReal THEN BEGIN Str0SoftReal:='SoftReal OFL'; EXIT; END;
  s0:=Double2String(n,0); s1:='';
  FOR i:=anz-LENGTH(s0) DOWNTO 1 DO s1:=s1+'0';
  Str0SoftReal:=s1+s0;
END (* Str0SoftReal *);

FUNCTION StrkSoftReal(n:DOUBLE; de:INTEGER):STRING;
VAR
  s0,s1:STRING; i,j:INTEGER;
  dzp,vzab:INTEGER;
BEGIN
  IF abs(n) > maxSoftReal THEN BEGIN StrkSoftReal:='SoftReal OFL'; EXIT; END;
  s0:=Double2String(n,de); s1:=''; j:=0;
  vzab:=POS('-',s0); dzp:=POS(',',s0);
  FOR i:=LENGTH(s0) DOWNTO 1 DO BEGIN
    IF ((i<dzp) or (dzp=0)) AND (i<>vzab) THEN BEGIN
      IF (j MOD 3 = 0) AND (j>0) THEN s1:='.'+s1;
      INC(j);
    END;
    s1:=s0[i]+s1;
  END;
  StrkSoftReal:=s1;
END (* StrkSoftReal *);

FUNCTION Str0kSoftReal(n:DOUBLE; anz,de:INTEGER):STRING;
VAR
  s0,s1:STRING; i:INTEGER;
BEGIN
  IF abs(n) > maxSoftReal THEN BEGIN Str0kSoftReal:='SoftReal OFL'; EXIT; END;
  s0:=Double2String(n,de); s1:='';
  FOR i:=anz-LENGTH(s0) DOWNTO 1 DO s1:=s1+'0';
  Str0kSoftReal:=s1+s0;
END (* Str0kSoftReal*);

FUNCTION Str0Giga(wert: CARD):STRING;
VAR
  zahl: DOUBLE;
  rest: CARD;
BEGIN
  rest:=wert MOD KILO; IF rest > (KILO-3) THEN rest:=rest-KILO;
  IF ABS(rest) < 3 THEN wert:=wert-rest;
  zahl:=wert;
  IF wert < 0 THEN Str0Giga:='NEGATIV ' + Str0Long( wert, 0)
  ELSE
    {$IFDEF DOS}
    IF (wert >= 0)    AND (wert < KILO)
      THEN Str0Giga:=Str0Long( wert, 0) ELSE
    IF (wert >= KILO) AND (wert < MEGA)
      THEN Str0Giga:=Double2String( zahl / KILO ,3) + ' K' ELSE
    IF (wert >= MEGA) AND (wert < GIGA)
      THEN Str0Giga:=Double2String( zahl / MEGA ,3) + ' M'
      ELSE Str0Giga:=Double2String( zahl / GIGA ,3) + ' G';
    {$ELSE}
    CASE wert OF
      0    .. KILO-1 : Str0Giga:=Str0Long( wert, 0);
      KILO .. MEGA-1 : Str0Giga:=Double2String( zahl / KILO ,3) + ' K';
      MEGA .. GIGA-1 : Str0Giga:=Double2String( zahl / MEGA ,3) + ' M';
      ELSE             Str0Giga:=Double2String( zahl / GIGA ,3) + ' G';
    END;
    {$ENDIF}
END;

FUNCTION Str2Int(S: STRING):INTEGER;
VAR w: WORD; Zahl: INTEGER;
BEGIN
  Val(S, Zahl, w);
  IF w = 0 THEN Str2Int:=Zahl ELSE Str2Int:=-1;
END;

FUNCTION Str2Card(S: STRING):CARD;
VAR w: WORD; Zahl: CARD;
BEGIN
  Val(S, Zahl, w);
  IF w = 0 THEN Str2Card:=Zahl ELSE Str2Card:=-1;
END;

PROCEDURE stdHilfe(hinweis: STRING);
BEGIN
  IF okstdProt THEN BEGIN
    IF hinweis<>'' THEN Writeln(stdProtokoll, hinweis);
    CLOSE(stdProtokoll);
  END;
  HALT;
END;

PROCEDURE Fehler_stdio(ursache: BYTE; name:STRING);
VAR
  t:STRING;
BEGIN
  CASE ursache OF
    1: t:='FileSize zu gro'+_sz;
    2: t:='Open';
    3: t:='Close';
    4: t:='EinDatei';
    ELSE t:='allgemein';
  END;
  t:='Fehler bei Datei: ' + name + ' - ' + t;
  IF okStdProt THEN Writeln(stdProtokoll,t) ELSE Writeln(t);
END;

PROCEDURE open_stdEingabe;
BEGIN
  IF stdEinPipe
    THEN BEGIN
      stdEinName:='input';
      {$IFNDEF DOS} stdEingabe:=input; {$ENDIF}
    END
    ELSE BEGIN
      ASSIGN(stdEingabe, stdEinName); {$I-} reset(stdEingabe); {$I+}
      IF IOResult<>0 THEN BEGIN
        Fehler_stdio(2,stdEinname);
        stdHilfe('dateien eingabe.txt ausgabe.txt');
      END
    END;
  IF okstdProt THEN Writeln(stdProtokoll, 'Eingabe: ' + stdEinName);
END;

PROCEDURE Close_stdEingabe;
BEGIN
  IF stdEinPipe
    THEN stdEinName:='input'
    ELSE BEGIN
      {$I-} CLOSE(stdEingabe); {$I+}
      IF IOResult<>0 THEN BEGIN
        Fehler_stdio(3,stdEinname);
        stdHilfe('dateien eingabe.txt ausgabe.txt');
      END
    END;
  IF okstdProt THEN Writeln(stdProtokoll, 'Eingabe: ', stdEinZahl, ' Zeilen');
END;

PROCEDURE Open_stdAusgabe;
BEGIN
  IF stdAusPipe
    THEN BEGIN
      stdAusName:='output';
      {$IFNDEF DOS} stdAusgabe:=output; {$ENDIF}
    END
    ELSE BEGIN
      ASSIGN(stdAusgabe, stdAusName); {$i-} REWRITE(stdAusgabe); {$i+}
      IF IOResult<>0 THEN BEGIN
        Fehler_stdio(2,stdAusname);
        stdHilfe('dateien eingabe.txt ausgabe.txt');
      END
    END;
  IF okstdProt THEN Writeln(stdProtokoll, 'Ausgabe: ' + stdAusName);
END;

PROCEDURE Close_stdAusgabe;
BEGIN
  IF stdAusPipe
    THEN stdAusName:='output'
    ELSE BEGIN
      {$I-} CLOSE(stdausgabe); {$I+}
      IF IOResult<>0 THEN BEGIN
        Fehler_stdio(3,stdAusname);
        stdHilfe('dateien eingabe.txt ausgabe.txt');
      END
    END;
  IF okstdProt THEN Writeln(stdProtokoll, 'Ausgabe: ', stdAusZahl, ' Zeilen');
END;

FUNCTION stdEOF: BOOLEAN;
BEGIN
  {$IFDEF DOS}
  IF stdEinPipe
    THEN stdEOF:=EOF
    ELSE {$ENDIF} stdEOF:=EOF(stdEingabe);
END;

FUNCTION stdReadln: string;
var
  Readzeile: string;
BEGIN
  {$IFDEF DOS} IF stdEinPipe
    THEN Readln(Readzeile)
    ELSE {$ENDIF} Readln(stdEingabe, Readzeile);
  INC(stdEinZahl);
  stdReadln:=Readzeile;
END;

PROCEDURE stdWriteln(Writezeile: string);
BEGIN
  {$IFDEF DOS} IF stdAusPipe
     THEN Writeln(Writezeile)
     ELSE {$ENDIF} Writeln(stdAusgabe, Writezeile);
  INC(stdAusZahl);
END;

PROCEDURE Open_stdProtokoll(name: StRING);
BEGIN
  ASSIGN(stdProtokoll, name);
  {$I-} REWRITE(stdProtokoll); {$I+}
  IF IOResult=0 THEN okstdProt:=True;
END;

PROCEDURE Close_stdProtokoll;
BEGIN
  IF okstdProt THEN CLOSE(stdProtokoll);
  okstdProt:=False;
END;

FUNCTION Bytes_stdFile(einname: STRING):CARD;
VAR
  bytes: CARD;
  x: INTEGER;
BEGIN
  bytes:=-1;
  ASSIGN(stdFile, einname);
  {$I-} RESET(stdFile,1); {$I+} x:=IORESULT;
  IF x<>0
    THEN BEGIN IF x=5 THEN Fehler_stdio(1,einname) ELSE Fehler_stdio(0,einname) END
    ELSE BEGIN
      bytes:=FileSize(stdFile);
      CLOSE(stdFile);
    END;
  IF bytes<0 THEN bytes:=MAXCARD;
  Bytes_stdFile:=bytes;
END;

FUNCTION Mittel_stdEingabe(einname: STRING):CARD;
VAR
  gesamt: CARD;
BEGIN
  gesamt:=0; stdEinZahl:=0;
  stdEinName:=einname;
  Open_stdEingabe;
  stdZeile:=stdReadln;
  WHILE (NOT stdEOF AND (stdEinZahl<1000)) DO BEGIN
    stdZeile:=stdReadLN;
    IF stdEinZahl <= 1000 THEN gesamt:=gesamt + Length(stdZeile);
  END;
  Close_stdEingabe;
  IF stdEinZahl=0 THEN stdEinZahl:=1;
  Mittel_stdEingabe:=gesamt DIV stdEinZahl;
END;

FUNCTION Zeilen_stdEingabe(einname: STRING):CARD;
BEGIN
  stdEinName:=einname; stdEinZahl:=0;
  Open_stdEingabe;
  stdReadln;
  WHILE NOT stdEOF DO BEGIN
    stdReadln;
  END;
  Close_stdEingabe;
  Zeilen_stdEingabe:=stdEinZahl;
END;

PROCEDURE Kopieren_Zeilen(einname,ausname: STRING);
BEGIN
  stdEinName:=einname; stdEinZahl:=0;
  stdAusName:=ausname; stdAusZahl:=0;
  Open_stdEingabe; Open_stdAusgabe;
  stdZeile:=stdReadln;
  WHILE NOT stdEOF DO BEGIN
    stdWriteln(stdZeile);
    stdZeile:=stdReadln;
  END;
  stdWriteln(stdZeile);
  Close_stdEingabe; Close_stdAusgabe;
END;

BEGIN
  {$IFNDEF DOS}
  Keyboard_OK:=True;
  (* Wenn man die Variable False setzt, kann jegliche Aktivität mit der
  Unit Keyboard unterbunden werden *)

  Keyboard_Auto:=False;
  (* Die Variable schaltet die automatische Nutzung von Keyboard aus.
     im Hauptprogramm m_ue_szte dann so gesteuert werden:

     InitKeyBoard;

     ... (Programmablauf)

     DoneKeyBoard;

     Aber: zB Nulldisk nutzt Keyboard_Start und KeyBoard_Stop
     das setzt Keyboard_OK und KeyBoard_Auto auf True

     Mit Keyboard_Auto = True wird in Taste0 und Keypressed0
     jedesmal automatisch InitKeyBoard und DoneKeyBoard aufgerufen.

     Aber siehe: KeyBoard_Start und KeyBoard_Stop
     zur Steuerung im NULLDISK-Projekt!
  *)
  {$ELSE}
  (* irgendein Start-Problem hat dieser N+ unter DOS :-( *)
  tempDOS:=Double2String(17.41, 3);     (* Writeln(tempDOS); *)
  tempDOS:=Double2String(22.84972, 3);  (* Writeln(tempDOS); *)
  {$ENDIF}

  stdEinZahl:=0; stdAusZahl:=0; stdEinPipe:=False; stdAusPipe:=False;
  okstdProt:=False;

  _codepage:=CP_WUNSCH;
  {$IFDEF LINUX}   _codepage:=0             {$ELSE}
  {$IFDEF DOS}     _codepage:=437           {$ELSE}
  {$IFDEF CP_FRAGE}
  {$IFDEF CP_AUS}   Writeln('Aktuelle Codepage der Konsole: ', GetConsoleCP, ' ', GetConsoleOutputCP); {$ENDIF}
                   _codepage:=GetConsoleCP
  {$ELSE}          _codepage:=1252          {$ENDIF} {$ENDIF} {$ENDIF} ;
  {$IFDEF CP_AUS} Writeln('Codepage/Stdio: ', _codepage); {$ENDIF} ;

  _AE2:=uml(1);   _OE2:=uml(2);   _UE2:=uml(3);
  _ae:= uml(11);  _oe:= uml(12);  _ue:= uml(13);
  _sz:= uml(0);
  _gr:= uml(21);  _h2:= uml(22);  _h3:= uml(23);  _pg:= uml(24);
  _eu:= uml(30);  _eu1:=uml(31);  _eu2:=uml(32);  _eu3:=uml(33);

  UMLAUTE:=_AE2 + _OE2 + _UE2 + _ae+ _oe + _ue + _sz + _gr + _h2 + _h3 + _pg + _eu + _eu1 + _eu2 + _eu3 ;
  ZEICHENSATZ0:='ABCDEFGHIJKLMNOPQRSTUVWXYYZabcdefghijklmnopqrstuvwxyz1234567890' + '!"$%&/()=?`[]{}\+*~''#,.-;:_<>|';
  ZEICHENSATZ:=ZEICHENSATZ0 + UMLAUTE;

END (* Stdio.TPU *).
