UNIT Watch;

{$I OsWahl.inc}

{$IFDEF DOS} {$M 65520,0,655360} {$N+}
{$ELSE} {$mode objfpc} {$H+}
        {$IFDEF X86_64} {$MAXSTACKSIZE $7FFFFFF} {$ENDIF}
{$ENDIF}

INTERFACE

USES Stdio;

CONST
  VERSION_INFO_Zeit = 'Watch   V 2.43 '
  {$IFDEF LINUX_32} + '(Linux 32)' {$ENDIF} {$IFDEF LINUX_64} + '(Linux 64)' {$ENDIF}
  {$IFDEF WIN_32}   + '(32bit)'    {$ENDIF} {$IFDEF WIN_64}   + '(64bit)'    {$ENDIF}
  {$IFDEF BIT_16}   + '(16bit)'    {$ENDIF} + ' 31.03.2025   (c) ALFWARE B.Schubert';

TYPE
  TDosTime = LONGINT;
  TUnxTime = CARD;
  TWinTime = COMP;

FUNCTION HoleTSUnx: TUnxTime;
FUNCTION DTWerteZuTSUnx(jahr, monat, tag, stunde, minute, sekunde, msek: WORD): TUnxTime;
FUNCTION FormatTSUnx(TS: TUnxTime): STRING;
FUNCTION FormatDTWerte(jahr, monat, tag, stunde, minute, sekunde, msek: WORD): STRING;
FUNCTION Format0DTWerte(jahr, monat, tag, stunde, minute, sekunde, msek: WORD): STRING;
PROCEDURE TSUnxZuDTWerte(TS: TUnxTime; VAR jahr, monat, tag, stunde, minute, sekunde, msek: WORD);

FUNCTION HoleTS: TDosTime;
FUNCTION DTWerteZuTS(jahr, monat, tag, stunde, minute, sekunde: WORD): TDosTime;
FUNCTION FormatTS(DT: TDosTime): STRING;
PROCEDURE TSZuDTWerte(DT: TDosTime; VAR jahr, monat, tag, stunde, minute, sekunde: WORD);

FUNCTION TSUnxZuTS(TS: TUnxTime): TDosTime;
FUNCTION TSZuTSUnx(DT: TDosTime): TUnxTime;

FUNCTION TSUnxZuTSWin(TS: TUnxTime): TWinTime;
FUNCTION DTWerteZuTSWin(jahr, monat, tag, stunde, minute, sekunde, msek: WORD): TWinTime;
FUNCTION FormatTSWin(TS: TWinTime): STRING;

FUNCTION TSWinZuTSUnx(TS: TWinTime): TUnxTime;
PROCEDURE TSWinZuDTWerte(TS: TWinTime; VAR jahr, monat, tag, stunde, minute, sekunde, msek: WORD);
FUNCTION TSWinZuTS(TS: TWinTime): TDosTime;
FUNCTION TSZuTSWin(DT: TDosTime): TWinTime;

FUNCTION IstSchaltjahr(jahr: WORD): BOOLEAN;
FUNCTION TageImMonat(jahr, monat: WORD): WORD;

PROCEDURE ParseDT(DTStr: STRING; VAR DT: TDosTime; VAR UT: TUnxTime);

FUNCTION HoleAktuellesJahr: WORD;

IMPLEMENTATION

USES
  Dos;

FUNCTION IstSchaltjahr(jahr: WORD):BOOLEAN;
BEGIN
  IF jahr MOD 100 <> 0
    THEN IstSchaltjahr := (jahr AND 3) = 0
    ELSE IstSchaltjahr := (jahr AND 15) = 0;
END;

FUNCTION TageImMonat(jahr, monat: WORD): WORD;
BEGIN
  IF monat = 2
    THEN TageImMonat := 28 + ORD(IstSchaltjahr(jahr))
    ELSE TageImMonat := 30 OR (monat xor (monat shr 3));
END;

PROCEDURE TSUnxZuDTWerte(TS: TUnxTime; VAR jahr, monat, tag, stunde, minute, sekunde, msek: WORD);
VAR
  tage: LONGINT;
BEGIN
  {$IFNDEF DOS}
  msek := TS MOD 1000;
  TS := TS DIV 1000;
  {$ENDIF}
  sekunde := TS MOD 60;
  TS := TS DIV 60;
  minute := TS MOD 60;
  TS := TS DIV 60;
  stunde := TS MOD 24;
  tage := TS DIV 24;
  jahr := 1970;
  WHILE tage >= 365 + ord(IstSchaltjahr(jahr)) DO BEGIN
    DEC(tage, 365 + ord(IstSchaltjahr(jahr)));
    INC(jahr);
  END;
  monat := 1;
  WHILE tage >= TageImmonat(jahr, monat) DO BEGIN
    DEC(tage, TageImmonat(jahr, monat));
    INC(monat);
  END;
  tag := tage + 1;
END;

FUNCTION DTWerteZuTSUnx(jahr, monat, tag, stunde, minute, sekunde, msek: WORD): TUnxTime;
VAR
  TS: TUnxTime;
  i, tage, TSMS: LONGINT;
BEGIN
  tage := 0;
  FOR i := 1970 TO jahr - 1 DO
    INC(tage, 365 + Ord(IstSchaltjahr(i)));
  FOR i := 1 TO monat - 1 DO
    INC(tage, tageImMonat(jahr, i));
  INC(tage, tag - 1);
  TSMS := tage * 86400 + LONGINT(stunde) * 3600 + LONGINT(minute) * 60 + LONGINT(sekunde);
  TS := TSMS;
  {$IFNDEF DOS} TS := TS * 1000 + LONGINT(msek) {$ENDIF};
  DTWerteZuTSUnx := TS;
END;

FUNCTION HoleTSUnx: TUnxTime;
VAR
  jahr, monat, tag, stunde, minute, sekunde, msek, dummy: WORD;
BEGIN
  jahr:=0; monat:=0; tag:=0; stunde:=0; minute:=0; sekunde:=0; msek:=0; dummy:=0;
  GetDate(jahr, monat, tag, dummy);
  GetTime(stunde, minute, sekunde, msek);
  HoleTSUnx := DTWerteZuTSUnx(jahr, monat, tag, stunde, minute, sekunde, msek);
END;

FUNCTION FormatDTWerte(jahr, monat, tag, stunde, minute, sekunde, msek: WORD): STRING;
BEGIN
  FormatDTWerte :=
    Str0Card(tag,2)     + '.' +
    Str0Card(monat,2)   + '.' +
    Str0Card(jahr,2)    + ' ' +
    Str0Card(stunde,2)  + ':' +
    Str0Card(minute,2)  + ':' +
    Str0Card(sekunde,2) + ',' +
    Str0Card(msek,3);
END;

FUNCTION Format0DTWerte(jahr, monat, tag, stunde, minute, sekunde, msek: WORD): STRING;
VAR
  temp: STRING;
BEGIN
  temp :=
    Str0Card(tag,2) +  '.' +
    Str0Card(monat,2) +  '.' +
    Str0Card(jahr,2);
  IF (stunde > 0) OR (minute > 0) OR (sekunde > 0) THEN
    temp := temp + ' ' +
    Str0Card(stunde,2) +  ':' +
    Str0Card(minute,2) +  ':' +
    Str0Card(sekunde,2);
  IF msek > 0 THEN
    temp := temp +  ',' +
    Str0Card(msek,3);
  Format0DTWerte := temp;
END;

FUNCTION FormatTSUnx(TS: TUnxTime): STRING;
VAR
  jahr, monat, tag, stunde, minute, sekunde, msek: WORD;
BEGIN
  jahr:=0; monat:=0; tag:=0; stunde:=0; minute:=0; sekunde:=0; msek:=0;
  TSUnxZuDTWerte(TS, jahr, monat, tag, stunde, minute, sekunde, msek);
  FormatTSUnx := FormatDTWerte(jahr, monat, tag, stunde, minute, sekunde, msek);
END;

FUNCTION DTWerteZuTS(jahr, monat, tag, stunde, minute, sekunde: WORD): TDosTime;
BEGIN
  IF jahr < 1980 THEN jahr := 1980;   { DOS erlaubt keine jahre vor 1980 }
  DTWerteZuTS :=
    (LONGINT(jahr - 1980) SHL 25) OR  { jahr (7 Bit) }
    (LONGINT(monat)       SHL 21) OR  { monat (4 Bit) }
    (LONGINT(tag)         SHL 16) OR  { tag (5 Bit) }
    (LONGINT(stunde)      SHL 11) OR  { stunde (5 Bit) }
    (LONGINT(minute)      SHL 5)  OR  { minute (6 Bit) }
    (LONGINT(sekunde      DIV 2));    { sekunde/2 (5 Bit) }
END;

FUNCTION HoleTS: TDosTime;
VAR
  jahr, monat, tag, stunde, minute, sekunde, dummy: WORD;
BEGIN
  jahr:=0; monat:=0; tag:=0; stunde:=0; minute:=0; sekunde:=0; dummy:=0;
  GetDate(jahr, monat, tag, dummy);
  GetTime(stunde, minute, sekunde, dummy);
  HoleTS := DTWerteZuTS(jahr, monat, tag, stunde, minute, sekunde);
END;

PROCEDURE TSZuDTWerte(DT: TDosTime; VAR jahr, monat, tag, stunde, minute, sekunde: WORD);
BEGIN
  jahr :=   ((DT SHR 25) AND $7F) + 180;
  monat :=   (DT SHR 21) AND $0F;
  tag :=     (DT SHR 16) AND $1F;
  stunde :=  (DT SHR 11) AND $1F;
  minute :=  (DT SHR 5)  AND $3F;
  sekunde := (DT         AND $1F) * 2;
END;

FUNCTION FormatTS(DT: TDosTime): STRING;
VAR
  stunde, minute, sekunde, jahr, monat, tag: WORD;
BEGIN
  jahr:=0; monat:=0; tag:=0; stunde:=0; minute:=0; sekunde:=0;
  TSZuDTWerte(DT, jahr, monat, tag, stunde, minute, sekunde);
  FormatTS := Format0DTWerte(jahr, monat, tag, stunde, minute, sekunde, 0);
END;

FUNCTION FormatTSWin(TS: TWinTime): STRING;
VAR
  jahr, monat, tag, stunde, minute, sekunde, msek: WORD;
BEGIN
  jahr:=0; monat:=0; tag:=0; stunde:=0; minute:=0; sekunde:=0; msek:=0;
  TSWinZuDTWerte(TS, jahr, monat, tag, stunde, minute, sekunde, msek);
  FormatTSWin := FormatDTWerte(jahr, monat, tag, stunde, minute, sekunde, msek);
END;

FUNCTION TSUnxZuTS(TS: TUnxTime): TDosTime;
VAR
  jahr, monat, tag, stunde, minute, sekunde, dummy: WORD;
BEGIN
  jahr:=0; monat:=0; tag:=0; stunde:=0; minute:=0; sekunde:=0; dummy:=0;
  TSUnxZuDTWerte(TS, jahr, monat, tag, stunde, minute, sekunde, dummy);
  TSUnxZuTS := DTWerteZuTS(jahr, monat, tag, stunde, minute, sekunde);
END;

FUNCTION TSZuTSUnx(DT: TDosTime): TUnxTime;
VAR
  jahr, monat, tag, stunde, minute, sekunde: WORD;
BEGIN
  jahr:=0; monat:=0; tag:=0; stunde:=0; minute:=0; sekunde:=0;
  TSZuDTWerte(DT, jahr, monat, tag, stunde, minute, sekunde);
  TSZuTSUnx := DTWerteZuTSUnx(jahr, monat, tag, stunde, minute, sekunde, 0);
END;

FUNCTION TSUnxZuTSWin(TS: TUnxTime): TWinTime;
VAR tempW: TWinTime;
BEGIN
  tempW := TS;
  {$IFDEF DOS}
  tempW := tempW + 11644473600.0;
  tempW := tempW * 1000.0;
  {$ELSE}
  tempW := tempW + 11644473600000;
  {$ENDIF}
  TSUnxZuTSWin := tempW;
END;

FUNCTION TSWinZuTSUnx(TS: TWinTime): TUnxTime;
VAR tempW: TWinTime;
BEGIN
  tempW := TS;
  {$IFDEF DOS}
  tempW := tempW / 1000.0;
  tempW := tempW - 11644473600.0;
  {$ELSE}
  tempW := tempW - 11644473600000;
  {$ENDIF}
  TSWinZuTSUnx := TRUNC(tempW);
END;

FUNCTION DTWerteZuTSWin(jahr, monat, tag, stunde, minute, sekunde, msek: WORD): TWinTime;
BEGIN
  DTWerteZuTSWin := TSUnxZuTSWin(DTWerteZuTSUnx(jahr, monat, tag, stunde, minute, sekunde, msek));
END;

PROCEDURE TSWinZuDTWerte(TS: TWinTime; VAR jahr, monat, tag, stunde, minute, sekunde, msek: WORD);
BEGIN
  TSUnxZuDTWerte(TSWinZuTSUnx(TS), jahr, monat, tag, stunde, minute, sekunde, msek);
END;

FUNCTION TSWinZuTS(TS: TWinTime): TDosTime;
BEGIN
  TSWinZuTS := TSUnxZuTS( TSWinZuTSUnx(TS) );
END;

FUNCTION TSZuTSWin(DT: TDosTime): TWinTime;
BEGIN
  TSZuTSWin := TSUnxZuTSWin( TSzuTSUnx(DT) );
END;

TYPE StringArray = ARRAY[0..5] OF STRING;

FUNCTION SplitString(S: STRING; Delim: CHAR; VAR teile: StringArray): INTEGER;
VAR
  anzahl, i, start, laenge: INTEGER;
BEGIN
  anzahl := 0;
  start := 1;
  laenge := Length(S);
  i := 1;
  WHILE i <= laenge DO BEGIN
    IF (S[i] = Delim) OR (i = laenge) THEN BEGIN
      IF i = laenge THEN INC(i);
      IF anzahl < High(teile) THEN BEGIN
        teile[anzahl] := Copy(S, start, i - start);
        INC(anzahl);
      END;
      start := i + 1;
    END;
    INC(i);
  END;
  SplitString := anzahl;
END;

FUNCTION ParseDecimal(S: STRING): INTEGER;
VAR
  NumStr: STRING;
  Code, Value, ExtraDigit: INTEGER;
BEGIN
  ExtraDigit := 0;
  {$IFNDEF BIT_64}
  NumStr := Copy(S, 1, 2);
  IF Length(S) >= 3 THEN ExtraDigit := Ord(S[3]) - Ord('0');
  {$ELSE}
  NumStr := Copy(S, 1, 3);
  IF Length(S) >= 4 THEN ExtraDigit := Ord(S[4]) - Ord('0');
  {$ENDIF}
  IF (NumStr = '') OR NOT (NumStr[1] in ['0'..'9']) OR
     (Length(NumStr) > 1) AND NOT (NumStr[2] in ['0'..'9']) OR
     (Length(NumStr) > 2) AND NOT (NumStr[3] in ['0'..'9'])
    THEN BEGIN ParseDecimal:=-1; EXIT; END;
  Val(NumStr, Value, Code);
  IF Code <> 0
    THEN BEGIN ParseDecimal:=-1; EXIT; END;
  IF (ExtraDigit > 5) OR
     (ExtraDigit = 5) AND (Value MOD 2 = 1)
    THEN INC(Value);
  ParseDecimal := Value;
END;

FUNCTION ParseExtend(S: STRING):STRING;
VAR
  t: STRING;
BEGIN
  t := S;
  IF Length(t)< 2 THEN t:= t + '0';
  IF Length(t)< 3 THEN t:= t + '0';
  ParseExtend := t;
END;

PROCEDURE ParseDT(DTStr: STRING; VAR DT: TDosTime; VAR UT: TUnxTime);
VAR
  jahr, monat, tag, stunde, minute, sekunde, msek: INTEGER;
  teile, teileD, teileZ: StringArray;
  anzahl, anzahlD, anzahlZ, HSPos: INTEGER;
  HSStr: STRING;
BEGIN
  UT := -1; teile[1] := ''; teileD[1] := ''; teileZ[1] := '';
  jahr := 0; monat := 0; tag := 0; stunde := 0; minute := 0; sekunde := 0; msek := 0;
  IF Length(DTStr) = 14 THEN BEGIN  (* JJJJMMTTHHMMSS ohne Trennzeichen *)
    jahr := Str2Card(Copy(DTStr, 1, 4));
    monat := Str2Card(Copy(DTStr, 5, 2));
    tag := Str2Card(Copy(DTStr, 7, 2));
    stunde := Str2Card(Copy(DTStr, 9, 2));
    minute := Str2Card(Copy(DTStr, 11, 2));
    sekunde := Str2Card(Copy(DTStr, 13, 2));
    DT := 0; UT := 0;
  END
  ELSE BEGIN
    anzahl := SplitString(DTStr, ' ', teile);
    IF (anzahl > 0) AND (anzahl <= 2) THEN BEGIN
       anzahlD := SplitString(teile[0], '.', teileD);
       IF anzahlD = 3 THEN BEGIN
         tag := Str2Card(teileD[0]);
         monat := Str2Card(teileD[1]);
         jahr := Str2Card(teileD[2]);
         IF jahr < 100 THEN INC(jahr, 2000);
       END;
       IF anzahl = 2 THEN BEGIN
         HSPos := Pos(',', teile[1]);
         IF HSPos > 0 THEN BEGIN
           HSStr := Copy(teile[1], HSPos + 1, 3);
           HSStr := ParseExtend(HSStr);
           msek := ParseDecimal(HSStr);
           teile[1] := Copy(teile[1], 1, HSPos - 1);
         END;
         anzahlZ := SplitString(teile[1], ':', teileZ);
         IF anzahlZ >= 2 THEN BEGIN
           stunde := Str2Card(teileZ[0]);
           minute := Str2Card(teileZ[1]);
           IF anzahlZ > 2
             THEN sekunde := Str2Card(teileZ[2])
             ELSE sekunde := 0;
         END;
       END;
       DT := 0; UT := 0;
    END;
  END;

  IF (jahr < 1980) OR (monat < 1) OR (monat > 12) OR (tag < 1) OR (tag > 31) THEN UT := -1;
  IF monat > tageImmonat(jahr, monat) THEN UT := -1;
  IF (stunde < 0) OR (stunde > 23) OR (minute < 0) OR (minute > 59) OR (sekunde < 0) OR (sekunde > 59) or
     (msek < 0) OR (msek > 999) THEN UT := -1;
  IF UT = 0 THEN BEGIN
     DT := DTWerteZuTS(jahr, monat, tag, stunde, minute, sekunde);
     UT := DTWerteZuTSUnx(jahr, monat, tag, stunde, minute, sekunde, msek);
  END;
END;

FUNCTION HoleAktuellesJahr: WORD;
VAR
  jahr, Dummy: WORD;
BEGIN
  jahr:=0; Dummy:=0;
  GetDate(jahr, Dummy, Dummy, Dummy);
  HoleAktuellesJahr := jahr;
END;

BEGIN
END.
