program Bench;

{$I OsWahl.inc}

{$IFDEF DOS} {$M 65520,0,655360} {$N+}
{$ELSE} {$mode objfpc} {$H+}
        {$IFDEF X86_64} {$MAXSTACKSIZE $7FFFFFF} {$ENDIF}
{$ENDIF}

uses
  Stdio, Zeit, Algebra;

const
  LBEZ = {$IFDEF DOS} 'LongInt' {$ELSE} 'Int64  ' {$ENDIF};
  Iterations = {$IFDEF DOS} 10000000 {$ELSE} 1000000000 {$ENDIF};

var
  i: longint;
  IntResult, IntA, IntB, IntF: Card;
  CompResult, CompA, CompB, CompF: Comp;
  SymbResult, SymbA, SymbB, SymbRest, SymbF, Symb11: ZAHL;
  Diff: array[0..18] of String;
  IterationsSymb :Card;

begin
  IntA := 987;
  IntB := 123;
  IntF := {$IFDEF DOS} 7 {$ELSE} 44 {$ENDIF};
  CompA := 987;
  CompB := 123;
  CompF := 44;
  IterationsSymb := Iterations div {$IFDEF DOS} 1000 {$ELSE} 10000 {$ENDIF};
  (* DOS  10.000.000 div 1.000  =  10.000 
     ELSE 1 Mrd      div 10.000 = 100.000 *)

  alCard2Zahl(987, SymbA);
  alCard2Zahl(123, SymbB);
  alCard2Zahl(44, SymbF);
  alCard2Zahl(11, Symb11);
  SymbResult := alNull;
  SymbRest := alNull;

  Intervall_Start(7);
  Intervall_Start(6);
  Intervall_Start(1);
  for i := 1 to Iterations do
    IntResult := IntA + IntB;
  Intervall_Stop(1);
  Writeln(StrCard(IntA),' + ', StrCard(IntB), ' = ', StrCard(IntResult));
  Diff[1] := Intervall_Dauer(1);
  writeln(LBEZ + ' Addition ', Diff[1], ' ms');

  Intervall_Start(2);
  for i := 1 to Iterations do
    IntResult := IntA * IntB;
  Intervall_Stop(2);
  Writeln(StrCard(IntA),' * ', StrCard(IntB), ' = ', StrCard(IntResult));
  Diff[2] := Intervall_Dauer(2);
  writeln(LBEZ + ' Multiplikation ', Diff[2], ' ms');

  Intervall_Start(3);
  for i := 1 to Iterations do
    IntResult := IntA div IntB;
  Intervall_Stop(3);
  Writeln(StrCard(IntA),' div ', StrCard(IntB), ' = ', StrCard(IntResult));
  Diff[3] := Intervall_Dauer(3);
  writeln(LBEZ + ' Division ', Diff[3], ' ms');

  Intervall_Start(4);
  for i := 1 to Iterations do
    IntResult := IntA mod IntB;
  Intervall_Stop(4);
  Writeln(StrCard(IntA),' mod ', StrCard(IntB), ' = ', StrCard(IntResult));
  Diff[4] := Intervall_Dauer(4);
  writeln(LBEZ + ' Modulo ', Diff[4], ' ms');

  Intervall_Start(5);
  for i := 1 to Iterations do
    IntResult := IntF * IntF * IntF * IntF * IntF * IntF * IntF * IntF * IntF * IntF * IntF;
  Intervall_Stop(5);
  Intervall_Stop(6);
  Writeln(StrCard(IntF),' ^ ', 11, ' = ', StrCard(IntResult));
  Diff[5] := Intervall_Dauer(5);
  writeln(LBEZ + ' Potenz ', Diff[5], ' ms');
  Diff[16]:=Intervall_Dauer(6);
  writeln(LBEZ + ' ', Diff[16], ' ms');

  Intervall_Start(6);
  Intervall_Start(1);
  for i := 1 to Iterations do
    CompResult := CompA + CompB;
  Intervall_Stop(1);
  Writeln(StrCompN(CompA),' + ', StrCompN(CompB), ' = ', StrCompN(CompResult));
  Diff[6] := Intervall_Dauer(1);
  writeln('Comp    Addition ', Diff[6], ' ms');

  Intervall_Start(2);
  for i := 1 to Iterations do
    CompResult := CompA * CompB;
  Intervall_Stop(2);
  Writeln(StrCompN(CompA),' * ', StrCompN(CompB), ' = ', StrCompN(CompResult));
  Diff[7] := Intervall_Dauer(2);
  writeln('Comp    Multiplikation ', Diff[7], ' ms');

  Intervall_Start(3);
  for i := 1 to Iterations do
    CompResult := CompA {$IFDEF WIN_64} div {$ELSE} / {$ENDIF} CompB;
  Intervall_Stop(3);
  Writeln(StrCompN(CompA),' / ', StrCompN(CompB), ' = ', StrCompN(CompResult));
  Diff[8] := Intervall_Dauer(3);
  writeln('Comp    Division ', Diff[8], ' ms');

  Intervall_Start(4);
  for i := 1 to Iterations do
    CompResult := CompA - (CompB * Trunc(CompA / CompB));
  Intervall_Stop(4);
  Writeln(StrCompN(CompA),' mod ', StrCompN(CompB), ' = ', StrCompN(CompResult));
  Diff[9] := Intervall_Dauer(4);
  writeln('Comp    Modulo ', Diff[9], ' ms');

  Intervall_Start(5);
  for i := 1 to Iterations do
    CompResult := CompF * CompF * CompF * CompF * CompF * CompF * CompF * CompF *CompF * CompF * CompF;
  Intervall_Stop(5);
  Intervall_Stop(6);
  Writeln(StrCompN(CompF),' ^ ', 11, ' = ', StrCompN(CompResult));
  Diff[10] := Intervall_Dauer(4);
  writeln('Comp    Potenz ', Diff[10], ' ms');
  Diff[17] := Intervall_Dauer(6);
  writeln('Comp    ', Diff[17], ' ms');

  Intervall_Start(6);
  Intervall_Start(1);
  for i := 1 to IterationsSymb do
    alAdd(SymbA, SymbB, SymbResult);
  Intervall_Stop(1);
  alWrite(SymbA); Write(' + '); alWrite(SymbB); Write(' = '); alWrite(SymbResult); Writeln;
  Diff[11] := Intervall_Dauer(1);
  writeln('Symb    Addition ', Diff[11], ' ms');

  Intervall_Start(2);
  for i := 1 to IterationsSymb do
    alMul(SymbA, SymbB, SymbResult);
  Intervall_Stop(2);
  alWrite(SymbA); Write(' * '); alWrite(SymbB); Write(' = '); alWrite(SymbResult); Writeln;
  Diff[12] := Intervall_Dauer(2);
  writeln('Symb    Multiplikation ', Diff[12], ' ms');

  Intervall_Start(3);
  for i := 1 to IterationsSymb do
    (* alDiv(SymbA, SymbB, SymbResult); *)
    alDivR(SymbA, SymbB, SymbResult, SymbRest);
  Intervall_Stop(3);
  alWrite(SymbA); Write(' / '); alWrite(SymbB); Write(' = '); alWrite(SymbResult); Writeln;
  Diff[13] := Intervall_Dauer(3);
  writeln('Symb    Division ', Diff[13], ' ms');

  Intervall_Start(4);
  for i := 1 to IterationsSymb do
    (* alMod(SymbA, SymbB, SymbResult); *)
    SymbResult := SymbRest;
  Intervall_Stop(4);
  alWrite(SymbA); Write(' mod '); alWrite(SymbB); Write(' = '); alWrite(SymbResult); Writeln;
  Diff[14] := Intervall_Dauer(4);
  writeln('Symb    Modulo ', Diff[14], ' ms');

  Intervall_Start(5);
  for i := 1 to IterationsSymb do
    alPot(SymbF, Symb11, SymbResult);
  Intervall_Stop(5);
  Intervall_Stop(6);
  Intervall_Stop(7);
  alWrite(SymbF); Write(' ^ '); alWrite(Symb11); Write(' = '); alWrite(SymbResult); Writeln;
  Diff[15] := Intervall_Dauer(5);
  writeln('Symb    Potenz ', Diff[15], ' ms');
  Diff[18] := Intervall_Dauer(6);
  writeln('Symb    ', Diff[18], ' ms');

  Writeln('Vergleich Addition ');
  Writeln('   ' + LBEZ + ' ', Diff[1], ' ms ');
  Writeln('   ' + 'Comp    ', Diff[6], ' ms ');
  Writeln('   ' + 'Symb    ', Diff[11], ' ms');
  Writeln('Vergleich Multiplikation ');
  Writeln('   ' + LBEZ + ' ', Diff[2], ' ms ');
  Writeln('   ' + 'Comp    ', Diff[7], ' ms ');
  Writeln('   ' + 'Symb    ', Diff[12], ' ms');
  Writeln('Vergleich Division ');
  Writeln('   ' + LBEZ + ' ', Diff[3], ' ms ');
  Writeln('   ' + 'Comp    ', Diff[8], ' ms ');
  Writeln('   ' + 'Symb    ', Diff[13], ' ms');
  Writeln('Vergleich Modulo ');
  Writeln('   ' + LBEZ + ' ', Diff[4], ' ms ');
  Writeln('   ' + 'Comp    ', Diff[9], ' ms ');
  Writeln('   ' + 'Symb    ', Diff[14], ' ms');
  Writeln('Vergleich Potenz ');
  Writeln('   ' + LBEZ + ' ', Diff[5], ' ms ');
  Writeln('   ' + 'Comp    ', Diff[10], ' ms ');
  Writeln('   ' + 'Symb    ', Diff[15], ' ms');
  Writeln('Vergleich Gesamt ');
  Writeln('   ' + LBEZ + ' ', Diff[16], ' ms ');
  Writeln('   ' + 'Comp    ', Diff[17], ' ms ');
  Writeln('   ' + 'Symb    ', Diff[18], ' ms');

  Writeln(StrCard(Iterations), ' Iterationen ', Intervall_Dauer(7));
  readln;
end.
